
/*]  Copyright (c) 2009-2010, Charles McGarvey  [**************************
**]  All rights reserved.
*
* vi:ts=4 sw=4 tw=75
*
* Distributable under the terms and conditions of the 2-clause BSD license;
* see the file COPYING for a complete text of the license.
*
**************************************************************************/

#ifndef _MOOF_DRAWABLE_HH_
#define _MOOF_DRAWABLE_HH_

/**
 * \file drawable.hh
 * Representation for an object that can be drawn to the screen.
 */

#include <moof/math.hh>


namespace moof {


/**
 * Interface for anything that can be drawn.
 */
class drawable
{
public:
	virtual ~drawable() {}

	virtual void draw(scalar alpha) const = 0;
};


} // namespace moof

#endif // _MOOF_DRAWABLE_HH_

